<?php
// Install the pointer table if it isn't already present
function phpBB_Groups_database($create = FALSE){
	global $wowdb, $addon_conf, $db_prefix;
	if($create !== FALSE){
		// Create the table
		if( $wowdb->query( "CREATE TABLE IF NOT EXISTS `".$db_prefix.$addon_conf['phpBB_Groups']['pointer_table_name']."` 
							(`phpbb` TEXT NOT NULL ,`roster` TEXT NOT NULL) 
							ENGINE = MYISAM 
							COMMENT = 'phpBB Groups Pointer Table';" 
						) && 
			$wowdb->query( "CREATE TABLE IF NOT EXISTS `".$db_prefix.$addon_conf['phpBB_Groups']['group_table_name']."` 
							(`rank` INT NOT NULL ,`group` INT NOT NULL) 
							ENGINE = MYISAM 
							COMMENT = 'phpBB Groups Group Table';" 
						)
		){
			return TRUE;
		}
	}else{
		// Look to see if we're installed
		unset($val);
		$q_tables=$wowdb->query('SHOW TABLES LIKE "%'.$db_prefix.'%"');
		while($r_tables = mysql_fetch_array($q_tables)){
			if( $r_tables[0] == $db_prefix.$addon_conf['phpBB_Groups']['pointer_table_name'] ||  
				$r_tables[0] == $db_prefix.$addon_conf['phpBB_Groups']['group_table_name']  ) {
				$val[$r_tables[0]] = TRUE;
			}
		}
		if( $val[$db_prefix.$addon_conf['phpBB_Groups']['group_table_name']] === TRUE && 
			$val[$db_prefix.$addon_conf['phpBB_Groups']['pointer_table_name']] === TRUE){
			return TRUE;
		}
	}
	
	return FALSE;
}

// Delete the table
function phpBB_Groups_database_delete(){
	global $wowdb, $addon_conf, $db_prefix;
	
	require_once($addon_conf['phpBB_Groups']['phpbb_dir']."/config.php");
	$phpbbdb = new wowdb;
	$phpbbdb->connect($dbhost, $dbuser, $dbpasswd, $dbname);
	unset($dbhost, $dbuser, $dbpasswd, $dbname, $dbms);
	
	// Wipe out the users in each group
	$addon_conf['phpBB_Groups']['query'] = $phpbbdb->query( "SELECT group_id FROM ".$table_prefix."groups WHERE group_name LIKE '".$addon_conf['phpBB_Groups']['group_prefix']."%'" );
	while($addon_conf['phpBB_Groups']['result'] = $phpbbdb->fetch_assoc($addon_conf['phpBB_Groups']['query'])){
		$phpbbdb->query( "DELETE FROM ".$table_prefix."user_group WHERE group_id =".$addon_conf['phpBB_Groups']['result']['group_id'] );
	}
	
	// Drop the tables
	if ( $wowdb->query("DROP TABLE ".$db_prefix.$addon_conf['phpBB_Groups']['pointer_table_name'] ) &&
		 $wowdb->query("DROP TABLE ".$db_prefix.$addon_conf['phpBB_Groups']['group_table_name'] )) {
		return TRUE;
	}
	return FALSE;
}

// Update the groups
function phpBB_Groups_update(){
	// Check if we're installed
	if(phpBB_Groups_database(FALSE) == FALSE){
		return 1;
	}
	global $wowdb, $addon_conf, $db_prefix;
	
	// Connect to phpBB database
	require_once($addon_conf['phpBB_Groups']['phpbb_dir']."/config.php");
	$phpbbdb = new wowdb;
	$phpbbdb->connect($dbhost, $dbuser, $dbpasswd, $dbname);
	unset($dbhost, $dbuser, $dbpasswd, $dbname, $dbms);
	
	// Get the mains name and group ID
	$addon_conf['phpBB_Groups']['query'] = $wowdb->query( 
		"SELECT m.name as username, g.group as group_id FROM 
		".$db_prefix.$addon_conf['phpBB_Groups']['group_table_name']." g, 
		".ROSTER_MEMBERSTABLE." m 
		WHERE m.guild_rank = g.rank AND m.".$addon_conf['phpBB_Groups']['identifier_category']." 
		LIKE '".$addon_conf['phpBB_Groups']['identifier_text']."'");
	while($addon_conf['phpBB_Groups']['result'] = $wowdb->fetch_assoc( $addon_conf['phpBB_Groups']['query'] )){
		$addon_conf['phpBB_Groups']['groups_entry'][] = $addon_conf['phpBB_Groups']['result'];
	}
	
	// Replace roster name with the names in the pointer table
	$addon_conf['phpBB_Groups']['query'] = $wowdb->query( "SELECT * FROM ".$db_prefix.$addon_conf['phpBB_Groups']['pointer_table_name'] );
	while($addon_conf['phpBB_Groups']['result'] = $wowdb->fetch_assoc( $addon_conf['phpBB_Groups']['query'] )){
		for($addon_conf['phpBB_Groups']['tmp'] = 0; $addon_conf['phpBB_Groups']['tmp'] < sizeof($addon_conf['phpBB_Groups']['groups_entry']); $addon_conf['phpBB_Groups']['tmp']++){
			if($addon_conf['phpBB_Groups']['groups_entry'][$addon_conf['phpBB_Groups']['tmp']]['username'] == $addon_conf['phpBB_Groups']['result']['roster']){
				$addon_conf['phpBB_Groups']['groups_entry'][$addon_conf['phpBB_Groups']['tmp']]['username'] = $addon_conf['phpBB_Groups']['result']['phpbb'];
			}
		}
	}
	
	// Get the user_id for each username
	for($addon_conf['phpBB_Groups']['tmp'] = 0; $addon_conf['phpBB_Groups']['tmp'] < sizeof($addon_conf['phpBB_Groups']['groups_entry']); $addon_conf['phpBB_Groups']['tmp']++){
		$addon_conf['phpBB_Groups']['tmp2'] = $phpbbdb->fetch_assoc($phpbbdb->query( "SELECT user_id FROM ".$table_prefix."users WHERE LOWER(username)=LOWER('".$addon_conf['phpBB_Groups']['groups_entry'][$addon_conf['phpBB_Groups']['tmp']]['username']."')" ));
		if($addon_conf['phpBB_Groups']['tmp2']['user_id'] != "" && is_numeric($addon_conf['phpBB_Groups']['tmp2']['user_id'])){
			$addon_conf['phpBB_Groups']['groups_entry'][$addon_conf['phpBB_Groups']['tmp']]['user_id'] = $addon_conf['phpBB_Groups']['tmp2']['user_id'];
		}		
	}
	
	// Wipe out the users in each group
	$addon_conf['phpBB_Groups']['query'] = $phpbbdb->query( "SELECT group_id FROM ".$table_prefix."groups WHERE group_name LIKE '".$addon_conf['phpBB_Groups']['group_prefix']."%'" );
	while($addon_conf['phpBB_Groups']['result'] = $phpbbdb->fetch_assoc($addon_conf['phpBB_Groups']['query'])){
		$phpbbdb->query( "DELETE FROM ".$table_prefix."user_group WHERE group_id =".$addon_conf['phpBB_Groups']['result']['group_id'] );
	}
	
	// Populate the groups
	for($addon_conf['phpBB_Groups']['tmp'] = 0; $addon_conf['phpBB_Groups']['tmp'] < sizeof($addon_conf['phpBB_Groups']['groups_entry']); $addon_conf['phpBB_Groups']['tmp']++){
		if(isset($addon_conf['phpBB_Groups']['groups_entry'][$addon_conf['phpBB_Groups']['tmp']]['user_id'])){
			$phpbbdb->query( "INSERT INTO ".$table_prefix."user_group SET group_id=".$addon_conf['phpBB_Groups']['groups_entry'][$addon_conf['phpBB_Groups']['tmp']]['group_id'].", user_id=".$addon_conf['phpBB_Groups']['groups_entry'][$addon_conf['phpBB_Groups']['tmp']]['user_id'].", user_pending=0" );
		}
	}
	
}

?>